/*
 * Academic License - for use in teaching, academic research, and meeting
 * course requirements at degree granting institutions only.  Not for
 * government, commercial, or other organizational use.
 *
 * File: AHRSControl.c
 *
 * Code generated for Simulink model 'AHRSControl'.
 *
 * Model version                  : 1.115
 * Simulink Coder version         : 9.3 (R2020a) 18-Nov-2019
 * C/C++ source code generated on : Fri Jul 10 14:44:58 2020
 *
 * Target selection: ert.tlc
 * Embedded hardware selection: Intel->x86-32 (Windows32)
 * Code generation objectives:
 *    1. Execution efficiency
 *    2. RAM efficiency
 * Validation result: Not run
 */

#include "AHRSControl.h"

/* Block states (default storage) */
DW_AHRSControl_f_T AHRSControl_DW;
extern void AHRSControl_Filter(real_T rtu_Signal, real_T rtu_prev_FeedbackSum,
  real_T *rty_filtered_Signal, real_T *rty_FeedbackSum);
extern void AHRSControl_pitch_feedback(real_T rtu_theta_cmd, const real_T
  rtu_voted_fb[5], real_T *rty_ds);
extern void AHRSControl_roll_feedback(real_T rtu_phi_cmd, const real_T
  rtu_voted_fb[5], real_T *rty_dc);
extern void AHRSControl_yaw_feedback(real_T rtu_r_cmd, const real_T
  rtu_voted_fb[5], real_T *rty_dT);
extern void AHRSControl_Heli_inner_loop(real_T rtu_theta_cmd, real_T rtu_phi_cmd,
  real_T rtu_r_cmd, const real_T rtu_voted_fb[5], real_T rty_actuator_commands[3]);
extern void AHRSControl_PitchLoop_Disable(void);
extern void AHRSControl_PitchLoop(real_T rtu_U, real_T *rty_Y);
extern void AHRSControl_RollLoop_Disable(void);
extern void AHRSControl_RollLoop(real_T rtu_U, real_T *rty_Y);
extern void AHRSControl_YawLoop_Disable(void);
extern void AHRSControl_YawLoop(real_T rtu_U, real_T *rty_Y);
extern void AHRSCon_Heli_outer_loop_Disable(void);
extern void AHRSControl_Heli_outer_loop(int16_T rtu_Pilot_theta_cmd, int16_T
  rtu_Pilot_phi_cmd, int16_T rtu_Pilot_r_cmd, const real_T rtu_voted_fb[5],
  real_T *rty_theta_cmd, real_T *rty_phi_cmd, real_T *rty_r_cmd);
extern void AHRSContro_AHRSLoopCtrl_Disable(void);
extern void AHRSControl_AHRSLoopCtrl(int16_T rtu_Pilot_theta_cmd, int16_T
  rtu_Pilot_phi_cmd, int16_T rtu_Pilot_r_cmd, const real_T rtu_voted_fb[5],
  real_T rty_actuator_commands[3]);
extern void AHRSControl_Avg_Value(const real_T rtu_AHRS1[5], const real_T
  rtu_AHRS2[5], const real_T rtu_AHRS3[5], boolean_T rtu_AHRS1_Valid, boolean_T
  rtu_AHRS2_Valid, boolean_T rtu_AHRS3_Valid, real_T rty_Avg_Value[5]);
extern void AHRSControl_Mid_Value(const real_T rtu_AHRS1[5], const real_T
  rtu_AHRS2[5], const real_T rtu_AHRS3[5], real_T rty_Mid_Value[5]);
extern void AHRSControl_Single_Value(const real_T rtu_AHRS1[5], const real_T
  rtu_AHRS2[5], const real_T rtu_AHRS3[5], boolean_T rtu_AHRS1_Valid, boolean_T
  rtu_AHRS2_Valid, boolean_T rtu_AHRS3_Valid, real_T rty_Single_Value[5]);
extern void AHRSControl_AHRS_voter(const AHRS_Bus *rtu_AHRS1, const AHRS_Bus
  *rtu_AHRS2, const AHRS_Bus *rtu_AHRS3, real_T rty_voted_fb[5]);

/* Output and update for Simulink Function: '<S4>/Filter' */
void AHRSControl_Filter(real_T rtu_Signal, real_T rtu_prev_FeedbackSum, real_T
  *rty_filtered_Signal, real_T *rty_FeedbackSum)
{
  real_T rtb_SumB21;

  /* Sum: '<S6>/SumA21' incorporates:
   *  Gain: '<S6>/a_2_1'
   *  Gain: '<S6>/s_1'
   *  SignalConversion generated from: '<S6>/Signal'
   *  SignalConversion generated from: '<S6>/prev_FeedbackSum'
   */
  rtb_SumB21 = (0.16840424129937498 * rtu_Signal) - (-0.66319151740124993 *
    rtu_prev_FeedbackSum);

  /* SignalConversion generated from: '<S6>/FeedbackSum' */
  *rty_FeedbackSum = rtb_SumB21;

  /* SignalConversion generated from: '<S6>/filtered_Signal' incorporates:
   *  SignalConversion generated from: '<S6>/prev_FeedbackSum'
   *  Sum: '<S6>/SumB21'
   */
  *rty_filtered_Signal = rtb_SumB21 + rtu_prev_FeedbackSum;
}

/* Output and update for Simulink Function: '<S4>/pitch_feedback' */
void AHRSControl_pitch_feedback(real_T rtu_theta_cmd, const real_T rtu_voted_fb
  [5], real_T *rty_ds)
{
  real_T rtb_ds;
  real_T rtb_Filter_caller_o2;
  int32_T i;

  /* Gain: '<S8>/Gain' incorporates:
   *  SignalConversion generated from: '<S8>/voted_fb'
   */
  rtb_ds = 0.0;
  for (i = 0; i < 5; i++) {
    rtb_ds += AHRSControl_ConstP.Gain_Gain[i] * rtu_voted_fb[i];
  }

  /* Sum: '<S8>/Sum5' incorporates:
   *  Gain: '<S8>/Gain'
   *  SignalConversion generated from: '<S8>/theta_cmd'
   */
  rtb_ds = rtu_theta_cmd - rtb_ds;

  /* FunctionCaller: '<S8>/Filter_caller' incorporates:
   *  UnitDelay: '<S8>/Unit Delay'
   */
  AHRSControl_Filter(rtb_ds, AHRSControl_DW.UnitDelay_DSTATE_j, &rtb_ds,
                     &rtb_Filter_caller_o2);

  /* SignalConversion generated from: '<S8>/ds' */
  *rty_ds = rtb_ds;

  /* Update for UnitDelay: '<S8>/Unit Delay' */
  AHRSControl_DW.UnitDelay_DSTATE_j = rtb_Filter_caller_o2;
}

/* Output and update for Simulink Function: '<S4>/roll_feedback' */
void AHRSControl_roll_feedback(real_T rtu_phi_cmd, const real_T rtu_voted_fb[5],
  real_T *rty_dc)
{
  real_T rtb_dc;
  real_T rtb_Filter_caller_o2;
  int32_T i;

  /* Gain: '<S9>/Gain' incorporates:
   *  SignalConversion generated from: '<S9>/voted_fb'
   */
  rtb_dc = 0.0;
  for (i = 0; i < 5; i++) {
    rtb_dc += AHRSControl_ConstP.Gain_Gain_d[i] * rtu_voted_fb[i];
  }

  /* Sum: '<S9>/Sum5' incorporates:
   *  Gain: '<S9>/Gain'
   *  SignalConversion generated from: '<S9>/phi_cmd'
   */
  rtb_dc = rtu_phi_cmd - rtb_dc;

  /* FunctionCaller: '<S9>/Filter_caller' incorporates:
   *  UnitDelay: '<S9>/Unit Delay'
   */
  AHRSControl_Filter(rtb_dc, AHRSControl_DW.UnitDelay_DSTATE_f, &rtb_dc,
                     &rtb_Filter_caller_o2);

  /* SignalConversion generated from: '<S9>/dc' */
  *rty_dc = rtb_dc;

  /* Update for UnitDelay: '<S9>/Unit Delay' */
  AHRSControl_DW.UnitDelay_DSTATE_f = rtb_Filter_caller_o2;
}

/* Output and update for Simulink Function: '<S4>/yaw_feedback' */
void AHRSControl_yaw_feedback(real_T rtu_r_cmd, const real_T rtu_voted_fb[5],
  real_T *rty_dT)
{
  real_T rtb_dT;
  real_T rtb_Filter_caller_o2;
  int32_T i;

  /* Gain: '<S10>/Gain' incorporates:
   *  SignalConversion generated from: '<S10>/voted_fb'
   */
  rtb_dT = 0.0;
  for (i = 0; i < 5; i++) {
    rtb_dT += AHRSControl_ConstP.Gain_Gain_b[i] * rtu_voted_fb[i];
  }

  /* Sum: '<S10>/Sum5' incorporates:
   *  Gain: '<S10>/Gain'
   *  SignalConversion generated from: '<S10>/r_cmd'
   */
  rtb_dT = rtu_r_cmd - rtb_dT;

  /* FunctionCaller: '<S10>/Filter_caller' incorporates:
   *  UnitDelay: '<S10>/Unit Delay'
   */
  AHRSControl_Filter(rtb_dT, AHRSControl_DW.UnitDelay_DSTATE, &rtb_dT,
                     &rtb_Filter_caller_o2);

  /* SignalConversion generated from: '<S10>/dT' */
  *rty_dT = rtb_dT;

  /* Update for UnitDelay: '<S10>/Unit Delay' */
  AHRSControl_DW.UnitDelay_DSTATE = rtb_Filter_caller_o2;
}

/* Output and update for Simulink Function: '<S2>/Heli_inner_loop' */
void AHRSControl_Heli_inner_loop(real_T rtu_theta_cmd, real_T rtu_phi_cmd,
  real_T rtu_r_cmd, const real_T rtu_voted_fb[5], real_T rty_actuator_commands[3])
{
  real_T rtb_pitch_feedback_caller;
  real_T rtb_TmpSignalConversionAtvote_o[5];
  real_T rtb_roll_feedback_caller;
  real_T rtb_yaw_feedback_caller;
  int32_T i;

  /* SignalConversion generated from: '<S4>/theta_cmd' */
  rtb_pitch_feedback_caller = rtu_theta_cmd;

  /* SignalConversion generated from: '<S4>/voted_fb' */
  for (i = 0; i < 5; i++) {
    rtb_TmpSignalConversionAtvote_o[i] = rtu_voted_fb[i];
  }

  /* End of SignalConversion generated from: '<S4>/voted_fb' */

  /* FunctionCaller: '<S4>/pitch_feedback_caller' incorporates:
   *  SignalConversion generated from: '<S4>/theta_cmd'
   */
  AHRSControl_pitch_feedback(rtu_theta_cmd, rtb_TmpSignalConversionAtvote_o,
    &rtb_pitch_feedback_caller);

  /* SignalConversion generated from: '<S4>/phi_cmd' */
  rtb_roll_feedback_caller = rtu_phi_cmd;

  /* FunctionCaller: '<S4>/roll_feedback_caller' incorporates:
   *  SignalConversion generated from: '<S4>/phi_cmd'
   */
  AHRSControl_roll_feedback(rtu_phi_cmd, rtb_TmpSignalConversionAtvote_o,
    &rtb_roll_feedback_caller);

  /* SignalConversion generated from: '<S4>/r_cmd' */
  rtb_yaw_feedback_caller = rtu_r_cmd;

  /* FunctionCaller: '<S4>/yaw_feedback_caller' incorporates:
   *  SignalConversion generated from: '<S4>/r_cmd'
   */
  AHRSControl_yaw_feedback(rtu_r_cmd, rtb_TmpSignalConversionAtvote_o,
    &rtb_yaw_feedback_caller);

  /* Gain: '<S4>/Gain' */
  rtb_pitch_feedback_caller *= 0.0033333333333333335;

  /* Saturate: '<S4>/Saturation' */
  if (rtb_pitch_feedback_caller > 0.1) {
    /* SignalConversion generated from: '<S4>/actuator_commands' */
    rty_actuator_commands[0] = 0.1;
  } else if (rtb_pitch_feedback_caller < -0.1) {
    /* SignalConversion generated from: '<S4>/actuator_commands' */
    rty_actuator_commands[0] = -0.1;
  } else {
    /* SignalConversion generated from: '<S4>/actuator_commands' */
    rty_actuator_commands[0] = rtb_pitch_feedback_caller;
  }

  /* Gain: '<S4>/Gain' */
  rtb_pitch_feedback_caller = 0.0033333333333333335 * rtb_roll_feedback_caller;

  /* Saturate: '<S4>/Saturation' */
  if (rtb_pitch_feedback_caller > 0.1) {
    /* SignalConversion generated from: '<S4>/actuator_commands' */
    rty_actuator_commands[1] = 0.1;
  } else if (rtb_pitch_feedback_caller < -0.1) {
    /* SignalConversion generated from: '<S4>/actuator_commands' */
    rty_actuator_commands[1] = -0.1;
  } else {
    /* SignalConversion generated from: '<S4>/actuator_commands' */
    rty_actuator_commands[1] = rtb_pitch_feedback_caller;
  }

  /* Gain: '<S4>/Gain' */
  rtb_pitch_feedback_caller = 0.0033333333333333335 * rtb_yaw_feedback_caller;

  /* Saturate: '<S4>/Saturation' */
  if (rtb_pitch_feedback_caller > 0.1) {
    /* SignalConversion generated from: '<S4>/actuator_commands' */
    rty_actuator_commands[2] = 0.1;
  } else if (rtb_pitch_feedback_caller < -0.1) {
    /* SignalConversion generated from: '<S4>/actuator_commands' */
    rty_actuator_commands[2] = -0.1;
  } else {
    /* SignalConversion generated from: '<S4>/actuator_commands' */
    rty_actuator_commands[2] = rtb_pitch_feedback_caller;
  }
}

/* Disable for Simulink Function: '<S5>/PitchLoop' */
void AHRSControl_PitchLoop_Disable(void)
{
  /* Disable for DiscreteIntegrator: '<S12>/Integrator' */
  AHRSControl_DW.Integrator_DSTATE = AHRSControl_DW.Integrator;
}

/* Output and update for Simulink Function: '<S5>/PitchLoop' */
void AHRSControl_PitchLoop(real_T rtu_U, real_T *rty_Y)
{
  /* DiscreteIntegrator: '<S12>/Integrator' */
  AHRSControl_DW.Integrator = AHRSControl_DW.Integrator_DSTATE;

  /* SignalConversion generated from: '<S12>/Y' incorporates:
   *  Gain: '<S12>/Gain'
   *  Gain: '<S12>/Gain1'
   *  SignalConversion generated from: '<S12>/U'
   *  Sum: '<S12>/Sum3'
   */
  *rty_Y = (0.01 * AHRSControl_DW.Integrator) + (1.13 * rtu_U);

  /* Update for DiscreteIntegrator: '<S12>/Integrator' incorporates:
   *  Gain: '<S12>/Gain2'
   *  SignalConversion generated from: '<S12>/U'
   */
  AHRSControl_DW.Integrator_DSTATE += 2.25 * rtu_U;
  if (AHRSControl_DW.Integrator_DSTATE >= 10.0) {
    AHRSControl_DW.Integrator_DSTATE = 10.0;
  } else {
    if (AHRSControl_DW.Integrator_DSTATE <= -10.0) {
      AHRSControl_DW.Integrator_DSTATE = -10.0;
    }
  }

  /* End of Update for DiscreteIntegrator: '<S12>/Integrator' */
}

/* Disable for Simulink Function: '<S5>/RollLoop' */
void AHRSControl_RollLoop_Disable(void)
{
  /* Disable for DiscreteIntegrator: '<S13>/Integrator1' */
  AHRSControl_DW.Integrator1_DSTATE = AHRSControl_DW.Integrator1;
}

/* Output and update for Simulink Function: '<S5>/RollLoop' */
void AHRSControl_RollLoop(real_T rtu_U, real_T *rty_Y)
{
  /* DiscreteIntegrator: '<S13>/Integrator1' */
  AHRSControl_DW.Integrator1 = AHRSControl_DW.Integrator1_DSTATE;

  /* SignalConversion generated from: '<S13>/Y' incorporates:
   *  Gain: '<S13>/Gain1'
   *  Gain: '<S13>/Gain2'
   *  SignalConversion generated from: '<S13>/U'
   *  Sum: '<S13>/Sum4'
   */
  *rty_Y = (0.01 * AHRSControl_DW.Integrator1) + (-0.086 * rtu_U);

  /* Update for DiscreteIntegrator: '<S13>/Integrator1' incorporates:
   *  Gain: '<S13>/Gain3'
   *  SignalConversion generated from: '<S13>/U'
   */
  AHRSControl_DW.Integrator1_DSTATE += -1.19 * rtu_U;
  if (AHRSControl_DW.Integrator1_DSTATE >= 10.0) {
    AHRSControl_DW.Integrator1_DSTATE = 10.0;
  } else {
    if (AHRSControl_DW.Integrator1_DSTATE <= -10.0) {
      AHRSControl_DW.Integrator1_DSTATE = -10.0;
    }
  }

  /* End of Update for DiscreteIntegrator: '<S13>/Integrator1' */
}

/* Disable for Simulink Function: '<S5>/YawLoop' */
void AHRSControl_YawLoop_Disable(void)
{
  /* Disable for DiscreteIntegrator: '<S14>/Integrator2' */
  AHRSControl_DW.Integrator2_DSTATE = AHRSControl_DW.Integrator2;
}

/* Output and update for Simulink Function: '<S5>/YawLoop' */
void AHRSControl_YawLoop(real_T rtu_U, real_T *rty_Y)
{
  /* DiscreteIntegrator: '<S14>/Integrator2' */
  AHRSControl_DW.Integrator2 = AHRSControl_DW.Integrator2_DSTATE;

  /* SignalConversion generated from: '<S14>/Y' incorporates:
   *  Gain: '<S14>/Gain1'
   *  Gain: '<S14>/Gain4'
   *  SignalConversion generated from: '<S14>/U'
   *  Sum: '<S14>/Sum5'
   */
  *rty_Y = (0.01 * AHRSControl_DW.Integrator2) + (1.33 * rtu_U);

  /* Update for DiscreteIntegrator: '<S14>/Integrator2' incorporates:
   *  Gain: '<S14>/Gain5'
   *  SignalConversion generated from: '<S14>/U'
   */
  AHRSControl_DW.Integrator2_DSTATE += -2.33 * rtu_U;
  if (AHRSControl_DW.Integrator2_DSTATE >= 10.0) {
    AHRSControl_DW.Integrator2_DSTATE = 10.0;
  } else {
    if (AHRSControl_DW.Integrator2_DSTATE <= -10.0) {
      AHRSControl_DW.Integrator2_DSTATE = -10.0;
    }
  }

  /* End of Update for DiscreteIntegrator: '<S14>/Integrator2' */
}

/* Disable for Simulink Function: '<S2>/Heli_outer_loop' */
void AHRSCon_Heli_outer_loop_Disable(void)
{
  /* Disable for S-Function (sfun_private_function_caller) generated from: '<S5>/RollLoop' incorporates:
   *  SubSystem: '<S5>/RollLoop'
   */
  AHRSControl_RollLoop_Disable();

  /* End of Disable for S-Function (sfun_private_function_caller) generated from: '<S5>/RollLoop' */

  /* Disable for S-Function (sfun_private_function_caller) generated from: '<S5>/YawLoop' incorporates:
   *  SubSystem: '<S5>/YawLoop'
   */
  AHRSControl_YawLoop_Disable();

  /* End of Disable for S-Function (sfun_private_function_caller) generated from: '<S5>/YawLoop' */

  /* Disable for S-Function (sfun_private_function_caller) generated from: '<S5>/PitchLoop' incorporates:
   *  SubSystem: '<S5>/PitchLoop'
   */
  AHRSControl_PitchLoop_Disable();

  /* End of Disable for S-Function (sfun_private_function_caller) generated from: '<S5>/PitchLoop' */
}

/* Output and update for Simulink Function: '<S2>/Heli_outer_loop' */
void AHRSControl_Heli_outer_loop(int16_T rtu_Pilot_theta_cmd, int16_T
  rtu_Pilot_phi_cmd, int16_T rtu_Pilot_r_cmd, const real_T rtu_voted_fb[5],
  real_T *rty_theta_cmd, real_T *rty_phi_cmd, real_T *rty_r_cmd)
{
  real_T rtb_Saturation_f;

  /* Sum: '<S5>/Sum1' incorporates:
   *  DataTypeConversion: '<S5>/TypeConversion1'
   *  Gain: '<S5>/Scaling1'
   *  SignalConversion generated from: '<S5>/Pilot_phi_cmd'
   *  SignalConversion generated from: '<S5>/voted_fb'
   */
  rtb_Saturation_f = (0.00091555528427991577 * ((real_T)rtu_Pilot_phi_cmd)) -
    rtu_voted_fb[1];

  /* FunctionCaller: '<S5>/RollLoop_caller' */
  AHRSControl_RollLoop(rtb_Saturation_f, &rtb_Saturation_f);

  /* Saturate: '<S5>/Saturation1' */
  if (rtb_Saturation_f > 30.0) {
    /* SignalConversion generated from: '<S5>/phi_cmd' */
    *rty_phi_cmd = 30.0;
  } else if (rtb_Saturation_f < -30.0) {
    /* SignalConversion generated from: '<S5>/phi_cmd' */
    *rty_phi_cmd = -30.0;
  } else {
    /* SignalConversion generated from: '<S5>/phi_cmd' */
    *rty_phi_cmd = rtb_Saturation_f;
  }

  /* End of Saturate: '<S5>/Saturation1' */

  /* Sum: '<S5>/Sum2' incorporates:
   *  DataTypeConversion: '<S5>/TypeConversion2'
   *  Gain: '<S5>/Scaling2'
   *  SignalConversion generated from: '<S5>/Pilot_r_cmd'
   *  SignalConversion generated from: '<S5>/voted_fb'
   */
  rtb_Saturation_f = (0.00045777764213995788 * ((real_T)rtu_Pilot_r_cmd)) -
    rtu_voted_fb[2];

  /* FunctionCaller: '<S5>/YawLoop_caller' */
  AHRSControl_YawLoop(rtb_Saturation_f, &rtb_Saturation_f);

  /* Saturate: '<S5>/Saturation2' */
  if (rtb_Saturation_f > 30.0) {
    /* SignalConversion generated from: '<S5>/r_cmd' */
    *rty_r_cmd = 30.0;
  } else if (rtb_Saturation_f < -30.0) {
    /* SignalConversion generated from: '<S5>/r_cmd' */
    *rty_r_cmd = -30.0;
  } else {
    /* SignalConversion generated from: '<S5>/r_cmd' */
    *rty_r_cmd = rtb_Saturation_f;
  }

  /* End of Saturate: '<S5>/Saturation2' */

  /* Sum: '<S5>/Sum' incorporates:
   *  DataTypeConversion: '<S5>/TypeConversion'
   *  Gain: '<S5>/Scaling'
   *  SignalConversion generated from: '<S5>/Pilot_theta_cmd'
   *  SignalConversion generated from: '<S5>/voted_fb'
   */
  rtb_Saturation_f = (0.00091555528427991577 * ((real_T)rtu_Pilot_theta_cmd)) -
    rtu_voted_fb[0];

  /* FunctionCaller: '<S5>/PitchLoop_caller' */
  AHRSControl_PitchLoop(rtb_Saturation_f, &rtb_Saturation_f);

  /* Saturate: '<S5>/Saturation' */
  if (rtb_Saturation_f > 30.0) {
    /* SignalConversion generated from: '<S5>/theta_cmd' */
    *rty_theta_cmd = 30.0;
  } else if (rtb_Saturation_f < -30.0) {
    /* SignalConversion generated from: '<S5>/theta_cmd' */
    *rty_theta_cmd = -30.0;
  } else {
    /* SignalConversion generated from: '<S5>/theta_cmd' */
    *rty_theta_cmd = rtb_Saturation_f;
  }

  /* End of Saturate: '<S5>/Saturation' */
}

/* Disable for Simulink Function: '<S1>/AHRSLoopCtrl' */
void AHRSContro_AHRSLoopCtrl_Disable(void)
{
  /* Disable for S-Function (sfun_private_function_caller) generated from: '<S2>/Heli_outer_loop' incorporates:
   *  SubSystem: '<S2>/Heli_outer_loop'
   */
  AHRSCon_Heli_outer_loop_Disable();

  /* End of Disable for S-Function (sfun_private_function_caller) generated from: '<S2>/Heli_outer_loop' */
}

/* Output and update for Simulink Function: '<S1>/AHRSLoopCtrl' */
void AHRSControl_AHRSLoopCtrl(int16_T rtu_Pilot_theta_cmd, int16_T
  rtu_Pilot_phi_cmd, int16_T rtu_Pilot_r_cmd, const real_T rtu_voted_fb[5],
  real_T rty_actuator_commands[3])
{
  real_T rtb_TmpSignalConversionAtvote_g[5];
  real_T rtb_Heli_outer_loop_caller_o1;
  real_T rtb_Heli_outer_loop_caller_o2;
  real_T rtb_Heli_outer_loop_caller_o3;
  int32_T i;

  /* SignalConversion generated from: '<S2>/voted_fb' */
  for (i = 0; i < 5; i++) {
    rtb_TmpSignalConversionAtvote_g[i] = rtu_voted_fb[i];
  }

  /* End of SignalConversion generated from: '<S2>/voted_fb' */

  /* FunctionCaller: '<S2>/Heli_outer_loop_caller' incorporates:
   *  SignalConversion generated from: '<S2>/Pilot_phi_cmd'
   *  SignalConversion generated from: '<S2>/Pilot_r_cmd'
   *  SignalConversion generated from: '<S2>/Pilot_theta_cmd'
   */
  AHRSControl_Heli_outer_loop(rtu_Pilot_theta_cmd, rtu_Pilot_phi_cmd,
    rtu_Pilot_r_cmd, rtb_TmpSignalConversionAtvote_g,
    &rtb_Heli_outer_loop_caller_o1, &rtb_Heli_outer_loop_caller_o2,
    &rtb_Heli_outer_loop_caller_o3);

  /* SignalConversion generated from: '<S2>/actuator_commands' incorporates:
   *  FunctionCaller: '<S2>/Heli_inner_loop_caller'
   */
  AHRSControl_Heli_inner_loop(rtb_Heli_outer_loop_caller_o1,
    rtb_Heli_outer_loop_caller_o2, rtb_Heli_outer_loop_caller_o3,
    rtb_TmpSignalConversionAtvote_g, rty_actuator_commands);
}

/* Output and update for Simulink Function: '<S3>/Avg_Value' */
void AHRSControl_Avg_Value(const real_T rtu_AHRS1[5], const real_T rtu_AHRS2[5],
  const real_T rtu_AHRS3[5], boolean_T rtu_AHRS1_Valid, boolean_T
  rtu_AHRS2_Valid, boolean_T rtu_AHRS3_Valid, real_T rty_Avg_Value[5])
{
  int32_T i;
  real_T rtu_AHRS2_Valid_0;
  real_T rtu_AHRS3_Valid_0;
  for (i = 0; i < 5; i++) {
    /* Switch: '<S15>/Switch' incorporates:
     *  SignalConversion generated from: '<S15>/AHRS1'
     *  SignalConversion generated from: '<S15>/AHRS1_Valid'
     */
    if (rtu_AHRS1_Valid) {
      rty_Avg_Value[i] = rtu_AHRS1[i];
    } else {
      rty_Avg_Value[i] = 0.0;
    }

    /* End of Switch: '<S15>/Switch' */

    /* Switch: '<S15>/Switch1' incorporates:
     *  SignalConversion generated from: '<S15>/AHRS2'
     *  SignalConversion generated from: '<S15>/AHRS2_Valid'
     */
    if (rtu_AHRS2_Valid) {
      rtu_AHRS2_Valid_0 = rtu_AHRS2[i];
    } else {
      rtu_AHRS2_Valid_0 = 0.0;
    }

    /* End of Switch: '<S15>/Switch1' */

    /* Switch: '<S15>/Switch2' incorporates:
     *  SignalConversion generated from: '<S15>/AHRS3'
     *  SignalConversion generated from: '<S15>/AHRS3_Valid'
     */
    if (rtu_AHRS3_Valid) {
      rtu_AHRS3_Valid_0 = rtu_AHRS3[i];
    } else {
      rtu_AHRS3_Valid_0 = 0.0;
    }

    /* End of Switch: '<S15>/Switch2' */

    /* SignalConversion generated from: '<S15>/Avg_Value' incorporates:
     *  Gain: '<S15>/Gain'
     *  Sum: '<S15>/Sum'
     */
    rty_Avg_Value[i] = ((rty_Avg_Value[i] + rtu_AHRS2_Valid_0) +
                        rtu_AHRS3_Valid_0) * 0.5;
  }
}

/* Output and update for Simulink Function: '<S3>/Mid_Value' */
void AHRSControl_Mid_Value(const real_T rtu_AHRS1[5], const real_T rtu_AHRS2[5],
  const real_T rtu_AHRS3[5], real_T rty_Mid_Value[5])
{
  int32_T i;

  /* SignalConversion generated from: '<S16>/Mid_Value' incorporates:
   *  MinMax: '<S16>/MinMax'
   *  MinMax: '<S16>/MinMax1'
   *  MinMax: '<S16>/MinMax2'
   *  MinMax: '<S16>/MinMax3'
   *  SignalConversion generated from: '<S16>/AHRS1'
   *  SignalConversion generated from: '<S16>/AHRS2'
   *  SignalConversion generated from: '<S16>/AHRS3'
   */
  for (i = 0; i < 5; i++) {
    rty_Mid_Value[i] = fmax(fmax(fmin(rtu_AHRS1[i], rtu_AHRS2[i]), fmin
      (rtu_AHRS2[i], rtu_AHRS3[i])), fmin(rtu_AHRS3[i], rtu_AHRS1[i]));
  }

  /* End of SignalConversion generated from: '<S16>/Mid_Value' */
}

/* Output and update for Simulink Function: '<S3>/Single_Value' */
void AHRSControl_Single_Value(const real_T rtu_AHRS1[5], const real_T rtu_AHRS2
  [5], const real_T rtu_AHRS3[5], boolean_T rtu_AHRS1_Valid, boolean_T
  rtu_AHRS2_Valid, boolean_T rtu_AHRS3_Valid, real_T rty_Single_Value[5])
{
  int32_T i;
  real_T rtu_AHRS2_Valid_0;
  real_T rtu_AHRS3_Valid_0;
  for (i = 0; i < 5; i++) {
    /* Switch: '<S18>/Switch' incorporates:
     *  SignalConversion generated from: '<S18>/AHRS1'
     *  SignalConversion generated from: '<S18>/AHRS1_Valid'
     */
    if (rtu_AHRS1_Valid) {
      rty_Single_Value[i] = rtu_AHRS1[i];
    } else {
      rty_Single_Value[i] = 0.0;
    }

    /* End of Switch: '<S18>/Switch' */

    /* Switch: '<S18>/Switch1' incorporates:
     *  SignalConversion generated from: '<S18>/AHRS2'
     *  SignalConversion generated from: '<S18>/AHRS2_Valid'
     */
    if (rtu_AHRS2_Valid) {
      rtu_AHRS2_Valid_0 = rtu_AHRS2[i];
    } else {
      rtu_AHRS2_Valid_0 = 0.0;
    }

    /* End of Switch: '<S18>/Switch1' */

    /* Switch: '<S18>/Switch2' incorporates:
     *  SignalConversion generated from: '<S18>/AHRS3'
     *  SignalConversion generated from: '<S18>/AHRS3_Valid'
     */
    if (rtu_AHRS3_Valid) {
      rtu_AHRS3_Valid_0 = rtu_AHRS3[i];
    } else {
      rtu_AHRS3_Valid_0 = 0.0;
    }

    /* End of Switch: '<S18>/Switch2' */

    /* SignalConversion generated from: '<S18>/Single_Value' incorporates:
     *  Sum: '<S18>/Sum'
     */
    rty_Single_Value[i] = (rty_Single_Value[i] + rtu_AHRS2_Valid_0) +
      rtu_AHRS3_Valid_0;
  }
}

/* Output and update for Simulink Function: '<S1>/AHRS_voter' */
void AHRSControl_AHRS_voter(const AHRS_Bus *rtu_AHRS1, const AHRS_Bus *rtu_AHRS2,
  const AHRS_Bus *rtu_AHRS3, real_T rty_voted_fb[5])
{
  real_T rtb_TmpSignalConversionAtAvg__o[5];
  real_T rtb_TmpSignalConversionAtAvg__d[5];
  real_T rtb_MultiportSwitch[5];
  real_T rtb_Single_Value_caller[5];
  real_T rtb_Avg_Value_caller[5];
  int32_T i;

  /* SignalConversion generated from: '<S3>/Avg_Value_caller' incorporates:
   *  SignalConversion generated from: '<S3>/AHRS1'
   */
  rtb_TmpSignalConversionAtAvg__o[0] = rtu_AHRS1->theta;
  rtb_TmpSignalConversionAtAvg__o[1] = rtu_AHRS1->phi;
  rtb_TmpSignalConversionAtAvg__o[2] = rtu_AHRS1->r;
  rtb_TmpSignalConversionAtAvg__o[3] = rtu_AHRS1->q;
  rtb_TmpSignalConversionAtAvg__o[4] = rtu_AHRS1->p;

  /* SignalConversion generated from: '<S3>/Avg_Value_caller' incorporates:
   *  SignalConversion generated from: '<S3>/AHRS2'
   */
  rtb_TmpSignalConversionAtAvg__d[0] = rtu_AHRS2->theta;
  rtb_TmpSignalConversionAtAvg__d[1] = rtu_AHRS2->phi;
  rtb_TmpSignalConversionAtAvg__d[2] = rtu_AHRS2->r;
  rtb_TmpSignalConversionAtAvg__d[3] = rtu_AHRS2->q;
  rtb_TmpSignalConversionAtAvg__d[4] = rtu_AHRS2->p;

  /* SignalConversion generated from: '<S3>/Avg_Value_caller' incorporates:
   *  SignalConversion generated from: '<S3>/AHRS3'
   */
  rtb_MultiportSwitch[0] = rtu_AHRS3->theta;
  rtb_MultiportSwitch[1] = rtu_AHRS3->phi;
  rtb_MultiportSwitch[2] = rtu_AHRS3->r;
  rtb_MultiportSwitch[3] = rtu_AHRS3->q;
  rtb_MultiportSwitch[4] = rtu_AHRS3->p;

  /* FunctionCaller: '<S3>/Single_Value_caller' incorporates:
   *  SignalConversion generated from: '<S3>/AHRS1'
   *  SignalConversion generated from: '<S3>/AHRS2'
   *  SignalConversion generated from: '<S3>/AHRS3'
   */
  AHRSControl_Single_Value(rtb_TmpSignalConversionAtAvg__o,
    rtb_TmpSignalConversionAtAvg__d, rtb_MultiportSwitch, rtu_AHRS1->valid,
    rtu_AHRS2->valid, rtu_AHRS3->valid, rtb_Single_Value_caller);

  /* FunctionCaller: '<S3>/Avg_Value_caller' incorporates:
   *  SignalConversion generated from: '<S3>/AHRS1'
   *  SignalConversion generated from: '<S3>/AHRS2'
   *  SignalConversion generated from: '<S3>/AHRS3'
   */
  AHRSControl_Avg_Value(rtb_TmpSignalConversionAtAvg__o,
                        rtb_TmpSignalConversionAtAvg__d, rtb_MultiportSwitch,
                        rtu_AHRS1->valid, rtu_AHRS2->valid, rtu_AHRS3->valid,
                        rtb_Avg_Value_caller);

  /* FunctionCaller: '<S3>/Mid_Value_caller' */
  AHRSControl_Mid_Value(rtb_TmpSignalConversionAtAvg__o,
                        rtb_TmpSignalConversionAtAvg__d, rtb_MultiportSwitch,
                        rty_voted_fb);

  /* MultiPortSwitch: '<S3>/MultiportSwitch' incorporates:
   *  SignalConversion generated from: '<S3>/AHRS1'
   *  SignalConversion generated from: '<S3>/AHRS2'
   *  SignalConversion generated from: '<S3>/AHRS3'
   *  Sum: '<S3>/Sum'
   */
  switch ((((uint32_T)(rtu_AHRS1->valid ? 1U : 0U)) + (rtu_AHRS2->valid ? 1U :
            0U)) + (rtu_AHRS3->valid ? 1U : 0U)) {
   case 0:
    /* SignalConversion generated from: '<S3>/voted_fb' */
    for (i = 0; i < 5; i++) {
      rty_voted_fb[i] = 0.0;
    }
    break;

   case 1:
    /* SignalConversion generated from: '<S3>/voted_fb' */
    for (i = 0; i < 5; i++) {
      rty_voted_fb[i] = rtb_Single_Value_caller[i];
    }
    break;

   case 2:
    /* SignalConversion generated from: '<S3>/voted_fb' */
    for (i = 0; i < 5; i++) {
      rty_voted_fb[i] = rtb_Avg_Value_caller[i];
    }
    break;

   default:
    /* no actions */
    break;
  }

  /* End of MultiPortSwitch: '<S3>/MultiportSwitch' */
}

/* Disable for referenced model: 'AHRSControl' */
void AHRSControl_Disable(void)
{
  /* Disable for S-Function (sfun_private_function_caller) generated from: '<Root>/AHRS_Control' incorporates:
   *  SubSystem: '<Root>/AHRS_Control'
   */
  /* Disable for S-Function (sfun_private_function_caller) generated from: '<S1>/AHRSLoopCtrl' incorporates:
   *  SubSystem: '<S1>/AHRSLoopCtrl'
   */
  AHRSContro_AHRSLoopCtrl_Disable();

  /* End of Disable for S-Function (sfun_private_function_caller) generated from: '<S1>/AHRSLoopCtrl' */
  /* End of Disable for S-Function (sfun_private_function_caller) generated from: '<Root>/AHRS_Control' */
}

/* Output and update for referenced model: 'AHRSControl' */
void AHRSControl_AHRS_Control(const int16_T rtu_Pilot_theta_cmd, const int16_T
  rtu_Pilot_phi_cmd, const int16_T rtu_Pilot_r_cmd, const AHRS_Bus *rtu_AHRS1,
  const AHRS_Bus *rtu_AHRS2, const AHRS_Bus *rtu_AHRS3, real_T
  rty_actuator_commands[3])
{
  AHRS_Bus rtb_TmpSignalConversionAtAHRS_c;
  AHRS_Bus rtb_TmpSignalConversionAtAHRS_i;
  AHRS_Bus rtb_TmpSignalConversionAtAHRS_e;
  real_T rtb_AHRS_voter_caller[5];

  /* Outputs for Function Call SubSystem: '<Root>/AHRS_Control' */
  /* SignalConversion generated from: '<S1>/AHRS1' */
  rtb_TmpSignalConversionAtAHRS_c = *rtu_AHRS1;

  /* SignalConversion generated from: '<S1>/AHRS2' */
  rtb_TmpSignalConversionAtAHRS_i = *rtu_AHRS2;

  /* SignalConversion generated from: '<S1>/AHRS3' */
  rtb_TmpSignalConversionAtAHRS_e = *rtu_AHRS3;

  /* FunctionCaller: '<S1>/AHRS_voter_caller' */
  AHRSControl_AHRS_voter(&rtb_TmpSignalConversionAtAHRS_c,
    &rtb_TmpSignalConversionAtAHRS_i, &rtb_TmpSignalConversionAtAHRS_e,
    rtb_AHRS_voter_caller);

  /* SignalConversion generated from: '<S1>/actuator_commands' incorporates:
   *  FunctionCaller: '<S1>/AHRSLoopCtrl_caller'
   *  SignalConversion generated from: '<S1>/Pilot_phi_cmd'
   *  SignalConversion generated from: '<S1>/Pilot_r_cmd'
   *  SignalConversion generated from: '<S1>/Pilot_theta_cmd'
   */
  AHRSControl_AHRSLoopCtrl(rtu_Pilot_theta_cmd, rtu_Pilot_phi_cmd,
    rtu_Pilot_r_cmd, rtb_AHRS_voter_caller, rty_actuator_commands);

  /* End of Outputs for SubSystem: '<Root>/AHRS_Control' */
}

/*
 * File trailer for generated code.
 *
 * [EOF]
 */
